var search_data = {"index":{"searchIndex":["control","applicative","functor","monad","either","helper","left","right","uniontype","<=>()","==()","==()",">>()","alias_names()","apply()","bimap()","each()","flat_map()","flat_map()","get_or_else()","inspect()","left?()","left?()","left_map()","lefts()","map()","map()","new()","or_else()","partition()","right?()","right?()","rights()","to_a()","to_s()","try()","when()","|()"],"longSearchIndex":["control","control::applicative","control::functor","control::monad","either","helper","left","right","uniontype","either#<=>()","left#==()","right#==()","control::monad#>>()","helper#alias_names()","control::applicative#apply()","either#bimap()","either#each()","control::monad#flat_map()","either#flat_map()","either#get_or_else()","either#inspect()","either#left?()","left#left?()","either#left_map()","either::lefts()","control::functor#map()","either#map()","either::new()","either#or_else()","either::partition()","either#right?()","right#right?()","either::rights()","either#to_a()","either#to_s()","either::try()","uniontype#when()","either#|()"],"info":[["Control","","Control.html","",""],["Control::Applicative","","Control/Applicative.html","",""],["Control::Functor","","Control/Functor.html","",""],["Control::Monad","","Control/Monad.html","",""],["Either","","Either.html","","<p>The `Either` union type represents values with two possibilities:\n<p>`Either a b` is either `Left a` or `Right …\n"],["Helper","","Helper.html","",""],["Left","","Left.html","",""],["Right","","Right.html","",""],["UnionType","","UnionType.html","",""],["<=>","Either","Either.html#method-i-3C-3D-3E","(other)","<p>comparable\n<p>Left &lt; Right\n\n"],["==","Left","Left.html#method-i-3D-3D","(other)",""],["==","Right","Right.html#method-i-3D-3D","(other)",""],[">>","Control::Monad","Control/Monad.html#method-i-3E-3E","(k)",""],["alias_names","Helper","Helper.html#method-i-alias_names","(names, m)",""],["apply","Control::Applicative","Control/Applicative.html#method-i-apply","()",""],["bimap","Either","Either.html#method-i-bimap","(lfn, rfn)","<p>`bimap` accept 2 lambdas, if it&#39;s [Right], apply the 2nd lambda, otherwise apply to the first lambda …\n"],["each","Either","Either.html#method-i-each","(&block)",""],["flat_map","Control::Monad","Control/Monad.html#method-i-flat_map","()",""],["flat_map","Either","Either.html#method-i-flat_map","()","<p>it override {Monad#flat_map}, as Haskell&#39;s `&gt;flat_map` method if it&#39;s {Right}, pass the value …\n"],["get_or_else","Either","Either.html#method-i-get_or_else","(e)","<p>get value `a` out from `Right a`, otherwise return `e` “`ruby Right.new(1).get_or_else(2) # =&gt; 1 …\n"],["inspect","Either","Either.html#method-i-inspect","()","<p>@return [String]\n"],["left?","Either","Either.html#method-i-left-3F","()","<p>default `false`, should override in {Left} or {Right} @return [Boolean]\n"],["left?","Left","Left.html#method-i-left-3F","()","<p>always true @return [Boolean]\n"],["left_map","Either","Either.html#method-i-left_map","()","<p>the opposit of #map, apply function to `Left e`, do nothing if it&#39;s `Right a`\n<p>“` ruby\n\n<pre class=\"ruby\"><span class=\"ruby-constant\">Right</span>.<span class=\"ruby-identifier\">new</span>(<span class=\"ruby-value\">1</span>).<span class=\"ruby-identifier\">left_map</span> <span class=\"ruby-operator\">...</span>\n</pre>\n"],["lefts","Either","Either.html#method-c-lefts","(list_of_either)","<p>filter only {Left} value from List of {Either}\n<p>“` ruby Either.lefts [Left.new(1),Right.new(5), Right.new(2) …\n"],["map","Control::Functor","Control/Functor.html#method-i-map","()",""],["map","Either","Either.html#method-i-map","()","<p>overide of Functor&#39;s `fmap`, apply function on `Right a`&#39;s value `a`, do nothing if it&#39;s …\n"],["new","Either","Either.html#method-c-new","(v = nil)","<p>Either only contain one value @v @return [Either]\n"],["or_else","Either","Either.html#method-i-or_else","(e)",""],["partition","Either","Either.html#method-c-partition","(list_of_either)","<p>partion a List of {Either} into a List of 2 List, one contains only {Left}, other contains only {Right} …\n"],["right?","Either","Either.html#method-i-right-3F","()","<p>(see #left?)\n"],["right?","Right","Right.html#method-i-right-3F","()","<p>always true @return [Boolean]\n"],["rights","Either","Either.html#method-c-rights","(list_of_either)","<p>filter only {Right} value from List of {Either}\n<p>“` ruby Either.rights [Left.new(1),Right.new(5), Right.new(2) …\n"],["to_a","Either","Either.html#method-i-to_a","()",""],["to_s","Either","Either.html#method-i-to_s","()",""],["try","Either","Either.html#method-c-try","()","<p>try something could raise exception, and wrap value into Right, exception into Left\n<p>@return [Either] “`ruby …\n"],["when","UnionType","UnionType.html#method-i-when","(what)","<p>similar to Scala&#39;s `match` for case class\n<p>will pattern match the value out and pass to matched lambda …\n"],["|","Either","Either.html#method-i-7C","(e)",""]]}}